'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var effector = require('effector');
var effectorReact = require('effector-react');
var pathToRegexp = require('path-to-regexp');

function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () {
                        return e[k];
                    }
                });
            }
        });
    }
    n['default'] = e;
    return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function m(){m=Object.assign||function(a){for(var c=1;c<arguments.length;c++){var g=arguments[c],h;for(h in g)Object.prototype.hasOwnProperty.call(g,h)&&(a[h]=g[h]);}return a};return m.apply(this,arguments)}var r,v=r||(r={});v.Pop="POP";v.Push="PUSH";v.Replace="REPLACE";var y="production"!==process.env.NODE_ENV?function(a){return Object.freeze(a)}:function(a){return a};function z(a,c){if(!a){"undefined"!==typeof console&&console.warn(c);try{throw Error(c);}catch(g){}}}
function A(a){a.preventDefault();a.returnValue="";}function E(){var a=[];return {get length(){return a.length},push:function(c){a.push(c);return function(){a=a.filter(function(a){return a!==c});}},call:function(c){a.forEach(function(a){return a&&a(c)});}}}
var F=function(a){function c(){var b=n.location,a=p.state||{};return [a.idx,y({pathname:b.pathname,search:b.search,hash:b.hash,state:a.usr||null,key:a.key||"default"})]}function g(b){if("string"===typeof b)var a=b;else {a=b.pathname;var c=b.search;b=b.hash;a=(void 0===a?"/":a)+(void 0===c?"":c)+(void 0===b?"":b);}return a}function h(b,a){void 0===a&&(a=null);var c=m,f=t;if("string"===typeof b){var d={};if(b){var e=b.indexOf("#");0<=e&&(d.hash=b.substr(e),b=b.substr(0,e));e=b.indexOf("?");0<=e&&(d.search=
b.substr(e),b=b.substr(0,e));b&&(d.pathname=b);}b=d;}return y(c({},f,{},b,{state:a,key:Math.random().toString(36).substr(2,8)}))}function w(b){x=b;b=c();l=b[0];t=b[1];B.call({action:x,location:t});}function C(b,a){function c(){C(b,a);}var f=r.Push,d=h(b,a);if(!k.length||(k.call({action:f,location:d,retry:c}),!1)){var e=[{usr:d.state,key:d.key,idx:l+1},g(d)];d=e[0];e=e[1];try{p.pushState(d,"",e);}catch(G){n.location.assign(e);}w(f);}}function D(a,c){function b(){D(a,c);}var f=r.Replace,d=h(a,c);k.length&&
(k.call({action:f,location:d,retry:b}),1)||(d=[{usr:d.state,key:d.key,idx:l},g(d)],p.replaceState(d[0],"",d[1]),w(f));}function q(a){p.go(a);}void 0===a&&(a={});a=a.window;var n=void 0===a?document.defaultView:a,p=n.history,u=null;n.addEventListener("popstate",function(){if(u)k.call(u),u=null;else {var a=r.Pop,f=c(),g=f[0];f=f[1];if(k.length)if(null!=g){var h=l-g;h&&(u={action:a,location:f,retry:function(){q(-1*h);}},q(h));}else "production"!==process.env.NODE_ENV?z(!1,"You are trying to block a POP navigation to a location that was not created by the history library. The block will fail silently in production, but in general you should do all navigation with the history library (instead of using window.history.pushState directly) to avoid this situation."):
void 0;else w(a);}});var x=r.Pop;a=c();var l=a[0],t=a[1],B=E(),k=E();null==l&&(l=0,p.replaceState(m({},p.state,{idx:l}),""));return {get action(){return x},get location(){return t},createHref:g,push:C,replace:D,go:q,back:function(){q(-1);},forward:function(){q(1);},listen:function(a){return B.push(a)},block:function(a){var b=k.push(a);1===k.length&&n.addEventListener("beforeunload",A);return function(){b();k.length||n.removeEventListener("beforeunload",A);}}}}();

var CACHE_SIZE_LIMIT = 1000;
var cache = new Map();

var getMatcher = function getMatcher(path) {
  var matcher = cache.get(path);

  if (!matcher) {
    matcher = pathToRegexp.match(path, {
      end: false
    });

    if (cache.size > CACHE_SIZE_LIMIT) {
      cache.clear();
    }

    cache.set(path, matcher);
  }

  return matcher;
};

var matchPath = function matchPath(pathname, path) {
  var matcher = getMatcher(path);
  var match = matcher(pathname);

  if (!match) {
    return null;
  }

  var url = match.path,
      params = match.params;
  return {
    params: params,
    isExact: url === pathname
  };
};
var getPathname = function getPathname(path, params) {
  return pathToRegexp.compile(path)(params);
};

var addPrefix = function addPrefix(value, prefix) {
  return !value.startsWith(prefix) ? "".concat(prefix).concat(value) : value;
};

var getNavigateFxOptions = function getNavigateFxOptions(location, path) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var _a;

  var navigateFxOptions = {};

  if (options.method) {
    navigateFxOptions.method = options.method;
  }

  if (options.search) {
    navigateFxOptions.search = options.search === true ? location.search : addPrefix(options.search, "?");
  }

  if (options.hash) {
    navigateFxOptions.hash = options.hash === true ? location.hash : addPrefix(options.hash, "#");
  }

  if (path) {
    var currentParams = ((_a = matchPath(location.pathname, path)) === null || _a === void 0 ? void 0 : _a.params) || {};
    var params = Object.assign(Object.assign({}, currentParams), options.params);
    navigateFxOptions.pathname = getPathname(path, params);
  } else {
    navigateFxOptions.pathname = location.pathname;
  }

  return navigateFxOptions;
};

var changeLocation = effector.createEvent();
var $location = effector.restore(changeLocation, F.location);
var $pathname = $location.map(function (location) {
  return location.pathname;
});
var $search = $location.map(function (location) {
  return location.search;
});
var $hash = $location.map(function (location) {
  return location.hash;
});
F.listen(function (_ref) {
  var location = _ref.location;
  return changeLocation(location);
});
var navigateFx = effector.createEffect(function (_a) {
  var method = _a.method,
      options = __rest(_a, ["method"]);

  method === "replace" ? F.replace(options) : F.push(options);
});
var getHref = function getHref(location, path) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var navigateFxOptions = getNavigateFxOptions(location, path, options);
  return F.createHref(navigateFxOptions);
};

var createRoute = function createRoute(path) {
  var updateMatch = effector.createEvent();
  var $match = effector.createStore(null).on(updateMatch, function (_state, match) {
    return match;
  });
  var $status = $match.map(function (match) {
    return Boolean(match);
  });
  var open = effector.createEvent();
  var close = effector.createEvent();
  effector.split({
    source: effector.sample({
      clock: $status,
      source: $match
    }),
    match: function match(_match) {
      return _match ? "open" : "close";
    },
    cases: {
      open: open,
      close: close
    }
  });
  var navigate = effector.createEvent();
  effector.sample({
    clock: navigate,
    source: $location,
    fn: function fn(location, options) {
      return getNavigateFxOptions(location, path, options);
    },
    target: navigateFx
  });

  var Route = function Route(_ref) {
    var exact = _ref.exact,
        children = _ref.children;
    var match = effectorReact.useStore($match);

    if (!match || exact && !match.isExact) {
      return null;
    }

    return /*#__PURE__*/React__namespace.createElement(React__namespace.Fragment, null, typeof children === "function" ? children(match) : children);
  };

  Route.path = path;
  Route.match = $match;
  Route.open = open;
  Route.close = close;
  Route.status = $status;
  Route.navigate = navigate; // Subscribe to pathname updates inside setTimeout to properly handle initial page load.

  setTimeout(function () {
    $pathname.watch(function (pathname) {
      var match = matchPath(pathname, path);
      updateMatch(match);
    });
  });
  return Route;
};
var navigateToCurrentRoute = effector.createEvent();
effector.sample({
  clock: navigateToCurrentRoute,
  source: $location,
  fn: function fn(location, options) {
    return getNavigateFxOptions(location, null, options);
  },
  target: navigateFx
});
var CurrentRoute = {
  path: null,
  navigate: navigateToCurrentRoute
};

var isModifiedEvent = function isModifiedEvent(event) {
  return Boolean(event.metaKey || event.altKey || event.ctrlKey || event.shiftKey);
};

var shouldNavigate = function shouldNavigate(event, target) {
  return (// onClick prevented default.
    !event.defaultPrevented && // Ignore everything but left clicks.
    event.button === 0 && ( // Let browser handle "target=_blank" etc.
    !target || target === "_self") && // Ignore clicks with modifier keys.
    !isModifiedEvent(event)
  );
};

var LinkInner = function LinkInner(_a, ref) {
  var Route = _a.to,
      params = _a.params,
      search = _a.search,
      hash = _a.hash,
      method = _a.method,
      onClick = _a.onClick,
      props = __rest(_a, ["to", "params", "search", "hash", "method", "onClick"]);

  var location = effectorReact.useStore($location);
  var navigateOptions = {
    params: params,
    search: search,
    hash: hash,
    method: method
  };
  var href = getHref(location, Route.path, navigateOptions);

  var handleClick = function handleClick(event) {
    try {
      if (onClick) onClick(event);
    } catch (error) {
      event.preventDefault();
      throw error;
    }

    if (shouldNavigate(event, props.target)) {
      event.preventDefault(); // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore https://github.com/kirillku/effector-easy-router/issues/1

      Route.navigate(navigateOptions);
    }
  };

  return /*#__PURE__*/React__namespace.createElement("a", Object.assign({
    ref: ref,
    href: href,
    onClick: handleClick
  }, props));
};

var Link = /*#__PURE__*/React__namespace.forwardRef(LinkInner);

var Redirect = function Redirect(_a) {
  var Route = _a.to,
      _a$method = _a.method,
      method = _a$method === void 0 ? "replace" : _a$method,
      options = __rest(_a, ["to", "method"]);

  React__namespace.useEffect(function () {
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore https://github.com/kirillku/effector-easy-router/issues/1
    Route.navigate(Object.assign({
      method: method
    }, options));
  }, []);
  return null;
};

var Switch = function Switch(_ref) {
  var children = _ref.children;
  var pathname = effectorReact.useStore($pathname);
  return React__namespace.Children.toArray(children).find(function (child) {
    var _a, _b;

    if (! /*#__PURE__*/React__namespace.isValidElement(child)) {
      return false;
    }

    var path = ((_a = child.type) === null || _a === void 0 ? void 0 : _a.path) || null;

    if (!path) {
      return true;
    }

    var match = matchPath(pathname, path);

    if (!match) {
      return false;
    }

    return ((_b = child.props) === null || _b === void 0 ? void 0 : _b.exact) ? match.isExact : true;
  }) || null;
};

exports.$hash = $hash;
exports.$location = $location;
exports.$pathname = $pathname;
exports.$search = $search;
exports.CurrentRoute = CurrentRoute;
exports.Link = Link;
exports.Redirect = Redirect;
exports.Switch = Switch;
exports.createRoute = createRoute;
//# sourceMappingURL=common.js.map
